<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/ButtonsCommanderPush.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('ButtonsCommanderPush_8cpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">ButtonsCommanderPush.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Commanders&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Push button with debounce.&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="Commanders_8h.html">Commanders.h</a>&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDER</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDERPUSH</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="classButtonsCommanderPush.html#ae5e721c350254591d3bd00b9f9e9de1b">   11</a></span>&#160;<a class="code" href="classButtonsCommanderPush.html#ae5e721c350254591d3bd00b9f9e9de1b">ButtonsCommanderPush::ButtonsCommanderPush</a>() : <a class="code" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a>(<a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    this-&gt;buttonPin = (GPIO_pin_t)DP_INVALID;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    this-&gt;lastButtonState = HIGH;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    this-&gt;lastDebounceTime = 0;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    this-&gt;debounceDelay = 50;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;}</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="classButtonsCommanderPush.html#ab8fb73b9998dc9fa58cfd1b26080ef1a">   19</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderPush.html#ab8fb73b9998dc9fa58cfd1b26080ef1a">ButtonsCommanderPush::begin</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">int</span> inButtonPin, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> inEventType, <span class="keywordtype">int</span> inData)</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;{   </div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    this-&gt;<a class="code" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a> = inId;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    this-&gt;buttonPin = Arduino_to_GPIO_pin(inButtonPin);</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    pinMode2f(this-&gt;buttonPin, INPUT_PULLUP);</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordflow">if</span> (inId != <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        this-&gt;<a class="code" href="classButtonsCommanderPush.html#afba3fe21579365395bc41a5d3f87b207">AddEvent</a>(inId, inEventType, inData);</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;}</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment">// Returns the index of the new added position.</span></div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classButtonsCommanderPush.html#afba3fe21579365395bc41a5d3f87b207">   31</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderPush.html#afba3fe21579365395bc41a5d3f87b207">ButtonsCommanderPush::AddEvent</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> inEventType, <span class="keywordtype">int</span> inData)</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;{</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <a class="code" href="structEvent.html">Event</a> *pEvent = <span class="keyword">new</span> <a class="code" href="structEvent.html">Event</a>();</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    pEvent-&gt;<a class="code" href="structEvent.html#afd30660358c854e191265792814ee078">Id</a> = inId;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    pEvent-&gt;<a class="code" href="structEvent.html#a30e11257e8ec1f970fb3159060bc2d17">EventType</a> = inEventType;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    pEvent-&gt;<a class="code" href="structEvent.html#add1010c7a7dfb056fee72df7c1575d90">Data</a> = inData;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    this-&gt;Events.<a class="code" href="classCMDRSCHAINEDLIST.html#a9376873ee15cd2ad4f239b832c700c56">AddItem</a>(pEvent);</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;}</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="classButtonsCommanderPush.html#a7b1af7744bd5bafaf42e355cb5a0a7dd">   40</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classButtonsCommanderPush.html#a7b1af7744bd5bafaf42e355cb5a0a7dd">ButtonsCommanderPush::loop</a>()</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;{</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_DEBUG_MODE</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keywordflow">if</span> (this-&gt;Events.<a class="code" href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">pFirst</a> == NULL)</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;This push button have no ID defined : call begin() !&quot;</span>));</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> foundID = <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordflow">if</span> (this-&gt;buttonPin == DP_INVALID)</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keywordflow">return</span> foundID;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="comment">// read the state of the switch into a local variable:</span></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">int</span> reading = digitalRead2f(this-&gt;buttonPin);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="comment">// check to see if you just pressed the button </span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="comment">// (i.e. the input went from LOW to HIGH), and you&#39;ve waited </span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="comment">// long enough since the last press to ignore any noise:  </span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="comment">// If the switch changed, due to noise or pressing:</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordflow">if</span> (reading != this-&gt;lastButtonState)</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="comment">// reset the debouncing timer</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        this-&gt;lastDebounceTime = millis();</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    }</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordflow">if</span> (this-&gt;lastDebounceTime &gt; 0 &amp;&amp; (millis() - this-&gt;lastDebounceTime) &gt; this-&gt;debounceDelay)</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    {</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="comment">// whatever the reading is at, it&#39;s been there for longer</span></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="comment">// than the debounce delay, so take it as the actual current state:</span></div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="comment">// if the button state has changed:</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keywordflow">if</span> (reading == this-&gt;lastButtonState)</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        {</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            <span class="comment">// only toggle the state if the new button state is LOW</span></div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            <span class="keywordflow">if</span> (reading == LOW)</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            {</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;                foundID = this-&gt;Events.<a class="code" href="classCMDRSCHAINEDLIST.html#ae382ce65496e09ba16dfa0fc6f311a27">pCurrentItem</a>-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEvent.html#afd30660358c854e191265792814ee078">Id</a>;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;                <a class="code" href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a>(foundID, </div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;                    this-&gt;Events.<a class="code" href="classCMDRSCHAINEDLIST.html#ae382ce65496e09ba16dfa0fc6f311a27">pCurrentItem</a>-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEvent.html#a30e11257e8ec1f970fb3159060bc2d17">EventType</a>,</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;                    this-&gt;Events.pCurrentItem-&gt;Obj-&gt;Data);</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;                this-&gt;Events.<a class="code" href="classCMDRSCHAINEDLIST.html#a7c95325c818d2e63d6ccf0b7f5250103">NextCurrent</a>();</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            }</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        }</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        this-&gt;lastDebounceTime = 0;    </div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    }</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;  </div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="comment">// save the reading.  Next time through the loop,</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="comment">// it&#39;ll be the lastButtonState:</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    this-&gt;lastButtonState = reading;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordflow">return</span> foundID;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;}</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_PRINT_COMMANDERS</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="keywordtype">void</span> ButtonsCommanderPush::printCommander()</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;{</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;    Push - Pin :&quot;</span>));</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    Serial.println(this-&gt;<a class="code" href="classButtonsCommanderPush.html#ad4a86075facec25cb45e703971c4e7c0">GetPin</a>());</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt;Event&gt;</a> *pCurr = this-&gt;Events.<a class="code" href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">pFirst</a>;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL) </div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    { </div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;        Event Id: &quot;</span>));</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        Serial.print(pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEvent.html#afd30660358c854e191265792814ee078">Id</a>);</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; / Event type: &quot;</span>));</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <a class="code" href="classCommanders.html#a5594e42de65bbf0bff7065c2eaaa3c7e">Commanders::printEventType</a>(pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEvent.html#a30e11257e8ec1f970fb3159060bc2d17">EventType</a>, <span class="keyword">true</span>);</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        <a class="code" href="classCommanders.html#af67a26985403e912486b851e3b44a6d6">Commanders::printEventData</a>(pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEvent.html#a30e11257e8ec1f970fb3159060bc2d17">EventType</a>, pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEvent.html#add1010c7a7dfb056fee72df7c1575d90">Data</a>);</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;&quot;</span>));</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">pNext</a>;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    }</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;}</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classCMDRSCHAINEDLISTITEM_html_a57edf0e3c4df958d02e9ef2d8af67c05"><div class="ttname"><a href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">CMDRSCHAINEDLISTITEM::pNext</a></div><div class="ttdeci">CMDRSCHAINEDLISTITEM * pNext</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00013">Chain.hpp:13</a></div></div>
<div class="ttc" id="classCommanders_html_af67a26985403e912486b851e3b44a6d6"><div class="ttname"><a href="classCommanders.html#af67a26985403e912486b851e3b44a6d6">Commanders::printEventData</a></div><div class="ttdeci">static void printEventData(COMMANDERS_EVENT_TYPE inEventType, int inEventData)</div></div>
<div class="ttc" id="Commanders_8h_html"><div class="ttname"><a href="Commanders_8h.html">Commanders.h</a></div></div>
<div class="ttc" id="classButtonsCommanderPush_html_ae5e721c350254591d3bd00b9f9e9de1b"><div class="ttname"><a href="classButtonsCommanderPush.html#ae5e721c350254591d3bd00b9f9e9de1b">ButtonsCommanderPush::ButtonsCommanderPush</a></div><div class="ttdeci">ButtonsCommanderPush()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8cpp_source.html#l00011">ButtonsCommanderPush.cpp:11</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html_a3b40667770ab04694a2ea85f11aebfe0"><div class="ttname"><a href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">ButtonsCommanderButton::Id</a></div><div class="ttdeci">unsigned long Id</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00019">ButtonsCommanderButton.hpp:19</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html"><div class="ttname"><a href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00015">ButtonsCommanderButton.hpp:15</a></div></div>
<div class="ttc" id="Events_8h_html_a48ad4dd16b8e22f2c8bc92b154479e92"><div class="ttname"><a href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a></div><div class="ttdeci">#define UNDEFINED_ID</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00038">Events.h:38</a></div></div>
<div class="ttc" id="classButtonsCommanderPush_html_ab8fb73b9998dc9fa58cfd1b26080ef1a"><div class="ttname"><a href="classButtonsCommanderPush.html#ab8fb73b9998dc9fa58cfd1b26080ef1a">ButtonsCommanderPush::begin</a></div><div class="ttdeci">void begin(unsigned long inId, int inButtonPin, COMMANDERS_EVENT_TYPE inEventType = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8cpp_source.html#l00019">ButtonsCommanderPush.cpp:19</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490c"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a></div><div class="ttdeci">COMMANDERS_EVENT_TYPE</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00025">Events.h:25</a></div></div>
<div class="ttc" id="classButtonsCommanderPush_html_afba3fe21579365395bc41a5d3f87b207"><div class="ttname"><a href="classButtonsCommanderPush.html#afba3fe21579365395bc41a5d3f87b207">ButtonsCommanderPush::AddEvent</a></div><div class="ttdeci">void AddEvent(unsigned long inId, COMMANDERS_EVENT_TYPE inEventType = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8cpp_source.html#l00031">ButtonsCommanderPush.cpp:31</a></div></div>
<div class="ttc" id="structEvent_html_afd30660358c854e191265792814ee078"><div class="ttname"><a href="structEvent.html#afd30660358c854e191265792814ee078">Event::Id</a></div><div class="ttdeci">unsigned long Id</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00014">ButtonsCommanderPush.hpp:14</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_a9376873ee15cd2ad4f239b832c700c56"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#a9376873ee15cd2ad4f239b832c700c56">CMDRSCHAINEDLIST::AddItem</a></div><div class="ttdeci">void AddItem(T *inpt)</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00061">Chain.hpp:61</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_a7c95325c818d2e63d6ccf0b7f5250103"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#a7c95325c818d2e63d6ccf0b7f5250103">CMDRSCHAINEDLIST::NextCurrent</a></div><div class="ttdeci">void NextCurrent()</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00085">Chain.hpp:85</a></div></div>
<div class="ttc" id="structEvent_html"><div class="ttname"><a href="structEvent.html">Event</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00012">ButtonsCommanderPush.hpp:12</a></div></div>
<div class="ttc" id="structEvent_html_add1010c7a7dfb056fee72df7c1575d90"><div class="ttname"><a href="structEvent.html#add1010c7a7dfb056fee72df7c1575d90">Event::Data</a></div><div class="ttdeci">int Data</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00016">ButtonsCommanderPush.hpp:16</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLISTITEM_html"><div class="ttname"><a href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt; Event &gt;</a></div></div>
<div class="ttc" id="classButtonsCommanderPush_html_a7b1af7744bd5bafaf42e355cb5a0a7dd"><div class="ttname"><a href="classButtonsCommanderPush.html#a7b1af7744bd5bafaf42e355cb5a0a7dd">ButtonsCommanderPush::loop</a></div><div class="ttdeci">unsigned long loop()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8cpp_source.html#l00040">ButtonsCommanderPush.cpp:40</a></div></div>
<div class="ttc" id="classCommanders_html_a7adbe54da67e90e0d39b58d69ac3add0"><div class="ttname"><a href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a></div><div class="ttdeci">static unsigned long RaiseEvent(unsigned long inId, COMMANDERS_EVENT_TYPE inEvent = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Commanders_8cpp_source.html#l00027">Commanders.cpp:27</a></div></div>
<div class="ttc" id="classButtonsCommanderPush_html_ad4a86075facec25cb45e703971c4e7c0"><div class="ttname"><a href="classButtonsCommanderPush.html#ad4a86075facec25cb45e703971c4e7c0">ButtonsCommanderPush::GetPin</a></div><div class="ttdeci">int GetPin() const </div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00066">ButtonsCommanderPush.hpp:66</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLISTITEM_html_aa4dd9b25f2fb55a906a2b052979e9cf2"><div class="ttname"><a href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">CMDRSCHAINEDLISTITEM::Obj</a></div><div class="ttdeci">T * Obj</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00011">Chain.hpp:11</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_a604e8c770db9bc2a7b11fa2aacc56993"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">CMDRSCHAINEDLIST::pFirst</a></div><div class="ttdeci">CMDRSCHAINEDLISTITEM&lt; T &gt; * pFirst</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00037">Chain.hpp:37</a></div></div>
<div class="ttc" id="structEvent_html_a30e11257e8ec1f970fb3159060bc2d17"><div class="ttname"><a href="structEvent.html#a30e11257e8ec1f970fb3159060bc2d17">Event::EventType</a></div><div class="ttdeci">COMMANDERS_EVENT_TYPE EventType</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderPush_8hpp_source.html#l00015">ButtonsCommanderPush.hpp:15</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_ae382ce65496e09ba16dfa0fc6f311a27"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#ae382ce65496e09ba16dfa0fc6f311a27">CMDRSCHAINEDLIST::pCurrentItem</a></div><div class="ttdeci">CMDRSCHAINEDLISTITEM&lt; T &gt; * pCurrentItem</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00039">Chain.hpp:39</a></div></div>
<div class="ttc" id="classCommanders_html_a5594e42de65bbf0bff7065c2eaaa3c7e"><div class="ttname"><a href="classCommanders.html#a5594e42de65bbf0bff7065c2eaaa3c7e">Commanders::printEventType</a></div><div class="ttdeci">static void printEventType(COMMANDERS_EVENT_TYPE inEventType, bool inDataFollow)</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>ButtonsCommanderPush.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
